// Copyright:	(C) Alexander S. Naumov aka GooRoo, 2004.
// E-mail:		gooroo@bk.ru
// Last update:	23/05/2004

using System;
using System.Runtime.Serialization;

namespace LoCoL.Conditions
{
	/// <summary>
	///  .
	/// </summary>
	[Serializable]
	public class OrCondition : Condition, ISerializable
	{

		#region Public Constructor

		/// <summary>
		/// .
		/// </summary>
		public OrCondition( Condition c1, Condition c2 )
			: base( c1, c2 )
		{
		}

		#endregion

		#region ISerializable Implementation

		/// <summary>
		///  .
		/// </summary>
		protected OrCondition(
			SerializationInfo info,
			StreamingContext context )
			: base( info, context )
		{
		}

		/// <summary>
		///    .
		/// </summary>
		public override void GetObjectData(
			SerializationInfo info,
			StreamingContext context )
		{
			base.GetObjectData( info, context );
		}

		#endregion

		#region Overrided Methods

		/// <summary>
		///   " "  
		///  .
		/// </summary>
		public override bool Evaluate( Automaton automaton )
		{
			return ((Condition)this[ 0 ]).Evaluate( automaton ) ||
				((Condition)this[ 1 ]).Evaluate( automaton );
		}

		#endregion

	}
}
