// Copyright:	(C) Alexander S. Naumov aka GooRoo, 2004.
// E-mail:		gooroo@bk.ru
// Last update:	23/05/2004

using System;

namespace LoCoL.Logs
{

	/// <summary>
	///       .
	/// </summary>
	public delegate void CycleEventHandler( AutomatonManager manager );

	/// <summary>
	///       
	///     .
	/// </summary>
	public delegate void NotificationProcessingEventHandler(
		Automaton automaton,
		Notification notification );

	/// <summary>
	///     .
	/// </summary>
	public delegate void InputInquireEventHandler(
		Automaton automaton,
		InputVariable variable,
		bool result );

	/// <summary>
	///     .
	/// </summary>
	public delegate void NotificationCheckingEventHandler(
		Automaton automaton,
		Notification notification,
		bool result );

	/// <summary>
	///    
	///    .
	/// </summary>
	public delegate void StateCheckingEventHandler(
		Automaton automaton,
		Automaton checkedAutomaton,
		State state,
		bool result );

	/// <summary>
	///    .
	/// </summary>
	public delegate void TransitionEventHandler(
		Automaton automaton,
		Transition transition );

	/// <summary>
	///     .
	/// </summary>
	public delegate void OutputInvocationEventHandler(
		Automaton automaton,
		OutputAction action );

	/// <summary>
	///    .
	/// </summary>
	public delegate void SendMessageEventHandler(
		Automaton targetAutomaton,
		Notification notification );

}
