// Copyright:	(C) Alexander S. Naumov aka GooRoo, 2004.
// E-mail:		gooroo@bk.ru
// Last update:	23/05/2004

using System;
using System.Runtime.Serialization;

namespace LoCoL.Conditions
{
	/// <summary>
	///  .
	/// </summary>
	[Serializable]
	public class NotCondition : Condition, ISerializable
	{

		#region Publci Constructor

		/// <summary>
		/// .
		/// </summary>
		public NotCondition( Condition c )
			: base( c )
		{
		}

		#endregion

		#region ISerializable Implementation

		/// <summary>
		///  .
		/// </summary>
		protected NotCondition(
			SerializationInfo info,
			StreamingContext context )
			: base( info, context )
		{
		}

		/// <summary>
		///    .
		/// </summary>
		public override void GetObjectData(
			SerializationInfo info,
			StreamingContext context )
		{
			base.GetObjectData( info, context );
		}

		#endregion

		#region Overrided Condition Methods

		/// <summary>
		///   " "  
		///  .
		/// </summary>
		public override bool Evaluate( Automaton automaton )
		{
			return !((Condition)this[ 0 ]).Evaluate( automaton );
		}

		#endregion

	}
}
